/*
	File: connManager.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Thread usato in copyManager per soddisfare le richieste di lettura e 
	scrittura
*/

import java.io.*;
import java.net.*;

public class connManager implements Runnable{
	private static final int MAXCOPY=10;
	private static final int BASEPORT1=4200;
	private static final int BASEPORT2=4600;
	
	private oneCopyManager[] copyVet;
	private boolean[] copiaCreata;
	
	private Socket sck=null;
	private DataInputStream in=null;
	private DataOutputStream out=null;
	
	private static int lastCopy=0;
	
	public connManager(Socket sck,oneCopyManager[] copyVet,
											boolean[] copiaCreata){
		super();
		this.sck=sck;
		this.copyVet=copyVet;
		this.copiaCreata=copiaCreata;
		try{
				in=new DataInputStream(sck.getInputStream());
				out=new DataOutputStream(sck.getOutputStream());
		}catch(IOException exc1){
			try{sck.close();} catch(IOException exc2) 
				{System.err.println("Errore 2 in connRead "+ exc2);}
			System.err.println("Errore 1 in connRead "+ exc1);
			System.exit(-1);
		}
	}
	
	public void run(){
		try{
				int servizio=in.readInt();
		
		switch(servizio){
			case 0:{//read
							System.out.println("DEBUG connManager; prima di getCopyPort");
							int port=getCopyPort();
							System.out.println("DEBUG connManager; prima di writeInt");
									out.writeInt(port);
							System.out.println("DEBUG connManager; prima di flush");
									out.flush();
							System.out.println("DEBUG connManager; dopo di flush");
							break;
			}//0
			case 1:{//write
									int indice=in.readInt();
									int dato=in.readInt();
									int secondi=in.readInt();
									for(int i=0;i<MAXCOPY;i++) 
										if(copiaCreata[i]){
											Socket mySck=new Socket("localhost",BASEPORT2+i);
											DataOutputStream myOut=new DataOutputStream(mySck.getOutputStream());
											
											myOut.writeInt(indice);
											myOut.writeInt(dato);
											myOut.writeInt(secondi);
											myOut.flush();
											
											myOut.close();
											mySck.close();
		 								}
			}//1
		}//switch
		
		}catch(IOException exc){
				System.err.println("**Errore in run() in connManager "+ exc);
				System.exit(-1);
		}
		
		try{
				System.out.println("DEBUG connManager; prima di in.close()");
				in.close();
				System.out.println("DEBUG connManager; prima di out.close()");
				out.close();
				System.out.println("DEBUG connManager; prima di sck.close()");
				sck.close();
				System.out.println("DEBUG connManager; dopo di sck.close()");
		}catch(IOException exc){
				System.err.println("Errore in run() in connManager "+ exc);
				System.exit(-1);
		}
	}//run
	
	private int getCopyPort(){
		for(int j=0;j<MAXCOPY;j++){
			lastCopy=(lastCopy==10)? 0 : lastCopy++;
			if(copiaCreata[lastCopy]) break;
		}
		return BASEPORT1+lastCopy;
	}//getCopyPort
} // class connManager