/*
	File: connRead.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Thread usato in oCMThreadRead. Soddisfa le richieste di lettura
*/

import java.io.*;
import java.net.*;

public class connRead implements Runnable{
	private Socket sck=null;
	private copiaLock myCopiaLock;
	private DataInputStream in=null;
	private DataOutputStream out=null;
	
	public connRead(Socket sck, copiaLock myCopiaLock){
		super();
		this.sck=sck;
		this.myCopiaLock=myCopiaLock;
		try{
				in=new DataInputStream(sck.getInputStream());
				out=new DataOutputStream(sck.getOutputStream());
		}catch(IOException exc1){
			try{sck.close();} catch(IOException exc2) {System.err.println("Errore 2 in connRead "+ exc2);}
			System.err.println("Errore 1 in connRead "+ exc1);
			System.exit(-1);
		}
	}//connRead
	
	public void run(){
		int indice=0;
		int secondi=0;
		int dato;
		// inizializzazione per non avere l'errore dal compilatore
		
		try{
			indice=in.readInt();
			secondi=in.readInt();
		}catch(IOException exc){
			System.err.println("Errore nelle readInt in connRead "+ exc);
			System.exit(-1);
		}
		
			dato=myCopiaLock.leggi(indice);
			try{
					Thread.sleep(secondi*1000);
			}catch(InterruptedException exc){
				System.out.println("sleep interrotta ");	
			}
		
		try{
				out.writeInt(dato);
				out.flush();
		}catch(IOException exc){
			System.err.println("Errore nelle writeInt in connRead "+ exc);
			System.exit(-1);
		}
		
		try{
				in.close();
				out.close();
				sck.close();
		}catch(IOException exc){
			System.err.println("Errore nella close in connRead "+ exc);
			System.exit(-1);
		}
	}//run
} // class connRead