/*
	File: connWrite.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Thread usato in oCMThreadWrite. Soddisfa le richieste di scrittura
*/

import java.io.*;
import java.net.*;

public class connWrite implements Runnable{
	private Socket sck=null;
	private copiaLock myCopiaLock;
	private DataInputStream in=null;
	private DataOutputStream out=null;
	
	public connWrite(Socket sck, copiaLock myCopiaLock){
		super();
		this.sck=sck;
		this.myCopiaLock=myCopiaLock;
		try{
				in=new DataInputStream(sck.getInputStream());
				out=new DataOutputStream(sck.getOutputStream());
		}catch(IOException exc1){
			try{sck.close();} catch(IOException exc2) {System.err.println("Errore 2 in connWrite "+ exc2);}
			System.err.println("Errore 1 in connWrite "+ exc1);
			System.exit(-1);
		}
	}//connWrite
	
	public void run(){
		int indice=0;
		int dato=0;
		int secondi=0;
		// inizializzazione per non avere l'errore dal compilatore
		
		try{
			indice=in.readInt();
			dato=in.readInt();
			secondi=in.readInt();
		}catch(IOException exc){
			System.err.println("Errore nelle readInt in connRead "+ exc);
			System.exit(-1);
		}
		
		//uso di blocco syncrhonized perch l'oggetto non deve risultare occupato 
		//durante la sleep 
		synchronized(myCopiaLock){
			myCopiaLock.scrivi(indice,dato);
			try{
					Thread.sleep(secondi*1000);
			}catch(InterruptedException exc){
				System.out.println("sleep interrotta ");	
			}
		}
		
		try{
				in.close();
				out.close();
				sck.close();
		}catch(IOException exc){
			System.err.println("Errore nella close in connWrite "+ exc);
			System.exit(-1);
		}
	}//run
} // class connWrite