/*
	File: copyClient.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Oggetto che rappresenta il cliente e tramite cui  possibile leggere e 
	scrivere le copie
*/

import java.io.*;
import java.net.*;

public class copyClient{
	protected String serverHost;
	protected int serverPort;
	
	protected Socket sckManager=null;
	protected Socket sckCopy=null;
	
	protected DataInputStream inManager=null;
	protected DataOutputStream outManager=null;
	protected DataInputStream inCopy=null;
	protected DataOutputStream outCopy=null;
	
	protected boolean firstRead=true;
	protected String hostCopia="localhost";
	protected int portaCopia=0;
	protected int nTentativi=0;
	
	
	public copyClient(String serverHost,int serverPort){
		this.serverHost=serverHost;
		this.serverPort=serverPort;
	}//copyClient
		

	public int leggi(int indice, int secondi){
		if(firstRead){
			firstRead=false;
			
	    try {
	         sckManager = new Socket(serverHost,serverPort);
	         outManager = new DataOutputStream(sckManager.getOutputStream());
	         inManager = new DataInputStream(sckManager.getInputStream());
	     } catch (UnknownHostException exc1) {
	         System.err.println("Don't know about host"+exc1);
	         System.exit(-1);
	     } catch (IOException exc2) {
	         System.err.println("Couldn't get I/O for the connection"+exc2);
	         System.exit(-1);
	     }
			
			try{
					outManager.writeInt(0);
					outManager.flush();
					portaCopia=inManager.readInt();
			}catch(IOException exc){
				System.err.println("Errore in leggi() in copyClient "+ exc);
				System.exit(-1);
			}
		}//if
					
    try {
         sckCopy = new Socket(hostCopia,portaCopia);
         outCopy = new DataOutputStream(sckCopy.getOutputStream());
         inCopy = new DataInputStream(sckCopy.getInputStream());
		} catch (UnknownHostException exc1) {
			 System.err.println("Connessione non riuscita, ritento "+exc1);
			 if(nTentativi<5){
			 	 nTentativi++;
			 	 firstRead=true;
			 	 leggi(indice,secondi);
			 }
			 System.err.println("Connessione NON riuscita ");
			 System.exit(-1);
		} catch (IOException exc2) {
			 System.err.println("Couldn't get I/O for the connection"+exc2);
			 System.exit(-1);
		}
		
		nTentativi=0;
		int risultato=readFromCopy(indice,secondi);
		
		try{
				outManager.close();
				inManager.close();
				sckManager.close();
		}catch(IOException exc){
				System.err.println("Errore in run() in connManager "+ exc);
				System.exit(-1);
		}
		
		return risultato;
	}//leggi
	
	
	private int readFromCopy(int indice, int secondi){
		int dato=100;
		try{
				outCopy.writeInt(indice);
				outCopy.writeInt(secondi);
				outCopy.flush();
				
				dato=inCopy.readInt();
				
				outCopy.close();
				inCopy.close();
				sckCopy.close();
		}catch(IOException exc){
			System.err.println("Errore in readFromCopy in copyClient "+ exc);
			System.exit(-1);
		}
		
		return dato;
	}//readFromCopy
	
	public void scrivi(int indice, int dato, int secondi){
    try {
         sckManager = new Socket(serverHost,serverPort);
         outManager = new DataOutputStream(sckManager.getOutputStream());
         inManager = new DataInputStream(sckManager.getInputStream());
     } catch (UnknownHostException exc1) {
         System.err.println("Don't know about host"+exc1);
         System.exit(-1);
     } catch (IOException exc2) {
         System.err.println("Couldn't get I/O for the connection"+exc2);
         System.exit(-1);
     }

		
		try{
				outManager.writeInt(1);
				outManager.writeInt(indice);
				outManager.writeInt(dato);
				outManager.writeInt(secondi);
				outManager.flush();
		}catch(IOException exc){
			System.err.println("Errore in scrivi in copyClient "+ exc);
			System.exit(-1);
		}
		
		
		try{
				outManager.close();
				inManager.close();
				sckManager.close();
		}catch(IOException exc){
				System.err.println("Errore in run() in connManager "+ exc);
				System.exit(-1);
		}
	}//scrivi
} // class copyClient