/*
	File: copyClientApplet.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Applet che rende disponibile un'interfaccia per riciedere i servizi (letture
	e scritture) alle copie
*/

import java.awt.*;
import java.awt.event.*;
import java.io.*;

// uso del frame per poter usare il programma sia come applicazione
// sia come applet
class myFrame extends Frame implements WindowListener {
	myFrame(String s1) {
		super(s1);
		addWindowListener(this);
	}
		
	public void windowClosing(WindowEvent evt) {
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	public void windowOpened(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowClosed(WindowEvent evt) {}
	public void windowActivated(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}

	
} // myFrame



class pressReadButton implements ActionListener {
	protected copyClient myCopyClient;
	protected TextField indiceRd;
	protected TextField secondiRd;
	protected TextField datoOut;
	
	public pressReadButton (copyClient myCopyClient,TextField indiceRd,TextField secondiRd,TextField datoOut) {
		this.myCopyClient=myCopyClient;
		this.indiceRd=indiceRd;
		this.secondiRd=secondiRd;
		this.datoOut=datoOut;
	}
	
	public void actionPerformed(ActionEvent evt) {
		int indice,dato,secondi;
		
		indice=(new Integer(indiceRd.getText())).intValue();
		secondi=(new Integer(secondiRd.getText())).intValue();
		
		dato=myCopyClient.leggi(indice,secondi);
		
		datoOut.setText(String.valueOf(dato));
	} // actionPerformed
}  // class pressReadButton



class pressWriteButton implements ActionListener {
	protected copyClient myCopyClient;
	protected TextField indiceWr;
	protected TextField datoWr;
	protected TextField secondiWr;

	public pressWriteButton (copyClient myCopyClient,TextField indiceWr,TextField datoWr,TextField secondiWr) {
		this.myCopyClient=myCopyClient;
		this.indiceWr=indiceWr;
		this.datoWr=datoWr;
		this.secondiWr=secondiWr;
	}
	
	public void actionPerformed(ActionEvent evt) {
		int indice,dato,secondi;
		
		indice=(new Integer(indiceWr.getText())).intValue();
		dato=(new Integer(datoWr.getText())).intValue();
		secondi=(new Integer(secondiWr.getText())).intValue();
		
		myCopyClient.scrivi(indice,dato,secondi);
	}
}  // class pressWriteButton



public class copyClientApplet extends java.applet.Applet {
	static myFrame mainWin = new myFrame("copyClient by Tiziano Moretti febbraio 99");
	static copyClientApplet app = new copyClientApplet();
	
	private static final int SVRPORT=1198;
	private static final String SVRHOST="localhost";
	copyClient myCopyClient = new copyClient(SVRHOST,SVRPORT);
	
	GridLayout grid1=new GridLayout(2,1);

	Label label1=new Label("indice:");
	TextField indiceRd=new TextField("3",3);
	Label label2=new Label("secondi di attesa:");
	TextField secondiRd=new TextField("1",3);
 	Button readButton=new Button("read");
 	TextField datoOut=new TextField("",3);
 	
	Label label3=new Label("indice:");
	TextField indiceWr=new TextField("3",3);
	Label label4=new Label("dato:");
	TextField datoWr=new TextField("3",3);
	Label label5=new Label("secondi di attesa:");
	TextField secondiWr=new TextField("1",3);
 	Button writeButton =new Button("write");
	
	Panel panel1=new Panel();
	Panel panel2=new Panel();
	
 	public void init() {
 		panel1.add(label1);
 		panel1.add(indiceRd);
 		panel1.add(label2);
 		panel1.add(secondiRd);
 		panel1.add(readButton);
 		panel1.add(datoOut);

 		panel2.add(label3);
 		panel2.add(indiceWr);
 		panel2.add(label4);
 		panel2.add(datoWr);
 		panel2.add(label5);
 		panel2.add(secondiWr);
 		panel2.add(writeButton);
 		
 		setLayout(grid1);
		add(panel1);
		add(panel2);
				
		readButton.addActionListener(new pressReadButton(myCopyClient,indiceRd,secondiRd,datoOut));
		writeButton.addActionListener(new pressWriteButton(myCopyClient,indiceWr,datoWr,secondiWr));
	} // init
	
	public static void main (String[] args) {
		app.init();
		app.start();
		mainWin.setSize(425,120);
		mainWin.add(app);
		mainWin.show();
	} // main
} // copyClientApplet