/*
	File: copyManager.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Gestore delle copie
*/

import java.io.*;
import java.net.*;

public class copyManager{
	private static final int MAXCOPY=10;
	private static final int BASEPORT1=4200;
	private static final int BASEPORT2=4600;
	private static final int SVRPORT=1198;
	
	private oneCopyManager[] copyVet=new oneCopyManager[MAXCOPY];
	private boolean[] copiaCreata=new boolean[MAXCOPY];
	
	private copyManagerAccept acceptThread;
	
	public copyManager(){
 		System.out.println("DEBUG copyManager; prima del for");
		for(int i=0;i<=4;i++){
			int port1=BASEPORT1+i;
			int port2=BASEPORT2+i;
			copyVet[i]=new oneCopyManager(port1,port2);
			copiaCreata[i]=true;
 		System.out.println("DEBUG copyManager; creato copyVet["+i+"]");
		}	
		for(int i=5;i<MAXCOPY;i++) copiaCreata[i]=false;
 		System.out.println("DEBUG copyManager; dopo false");
 		
		acceptThread=new copyManagerAccept(SVRPORT,copyVet,copiaCreata);
 		System.out.println("DEBUG copyManager; dopo accept");
		new Thread(acceptThread).start();
 		System.out.println("DEBUG copyManager; start del thread");
	}//copyManager
	
	public void createCopy(){
		copiaLock tmpCopiaLock=new copiaLock();
		
		//la nuova copia deve essere identica a quelle gi create
		//ricerca di una copia esistente:
		for(int i=0;i<MAXCOPY;i++){
			if(copiaCreata[i]) tmpCopiaLock=copyVet[i].getCopiaLock(); 	
			break;
		}
		
		for(int i=0;i<MAXCOPY;i++)
			if(! copiaCreata[i]) {
				copiaCreata[i]=true;
				int port1=BASEPORT1+i;
				int port2=BASEPORT2+i;
				copyVet[i]=new oneCopyManager(port1,port2,tmpCopiaLock);
				copiaCreata[i]=true;
				break;
			}
			//al massimo 10 copie contemporanee: possibile estensione con struttura 
			//dinamica (lista) 
		acceptThread.aggiorna(copyVet,copiaCreata);
	}//createCopy
	
	public String printCopie(){
		String str=" ";
		
		for(int i=0;i<MAXCOPY;i++)
			if(copiaCreata[i]) str=str+" copia: "+i+"\n"+copyVet[i].toString()+"\n";
			
		return str;
	}//printCopie
	
	
	public void destroyCopy(){
		for(int i=0;i<MAXCOPY;i++)
			if(copiaCreata[i]) {
				copiaCreata[i]=false;
				try{ 
						copyVet[i].finalize();
				}catch(Throwable exc){System.err.println("Errore in finalize "+exc); System.exit(-1);} 
				break;
			}
		acceptThread.aggiorna(copyVet,copiaCreata);
	}//destroyCopy
} // class copyManager