/*
	File: copyManagerApplet.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Applet per interagire attraverso una interfaccia grafica con il gestore delle
	copie
*/

import java.awt.*;
import java.awt.event.*;
import java.io.*;

// uso del frame per poter usare il programma sia come applicazione
// sia come applet
class myFrame extends Frame implements WindowListener {
	myFrame(String s1) {
		super(s1);
		addWindowListener(this);
	}
		
	public void windowClosing(WindowEvent evt) {
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	public void windowOpened(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowClosed(WindowEvent evt) {}
	public void windowActivated(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}

	
} // myFrame

	
class pressCreateCopyButton implements ActionListener {
	protected copyManager myCopyManager;
	
	public pressCreateCopyButton (copyManager myCopyManager) {
		this.myCopyManager=myCopyManager;
	}
	
	public void actionPerformed(ActionEvent evt) {
		myCopyManager.createCopy();
	} // actionPerformed
	
}  // class pressCreateCopyButton


class pressDestroyCopyButton implements ActionListener {
	protected copyManager myCopyManager;
	
	public pressDestroyCopyButton (copyManager myCopyManager) {
		this.myCopyManager=myCopyManager;
	}
	
	public void actionPerformed(ActionEvent evt) {
		myCopyManager.destroyCopy();
	}
}  // class pressDestroyCopyButton


class pressDisplayButton implements ActionListener {
	protected copyManager myCopyManager;
	protected TextArea winOut1;
	
	public pressDisplayButton (copyManager myCopyManager, TextArea winOut1) {
		this.myCopyManager=myCopyManager;
		this.winOut1=winOut1;
	}
	
	public void actionPerformed(ActionEvent evt) {
		winOut1.setText(myCopyManager.printCopie());
	} // actionPerformed
}  // class pressDisplayButton


public class copyManagerApplet extends java.applet.Applet {
	static myFrame mainWin = new myFrame("copyManager by Tiziano Moretti febbraio 99");
	static copyManagerApplet app = new copyManagerApplet();
	
	copyManager myCopyManager = new copyManager();
	
	TextArea winOut1 = new TextArea("Output windows",24,40);
	
	Button createCopyButton = new Button("create copy");
 	Button destroyCopyButton = new Button("destroy copy");
 	Button displayButton = new Button("display");
 	
 	public void init() {
 		System.out.println("DEBUG copyManagerApplet; init");
		add(winOut1);
		add(createCopyButton);
		add(destroyCopyButton);
		add(displayButton);
				
 		createCopyButton.addActionListener(new pressCreateCopyButton(myCopyManager));
		destroyCopyButton.addActionListener(new pressDestroyCopyButton(myCopyManager));
		displayButton.addActionListener(new pressDisplayButton(myCopyManager,winOut1));
	} // init
	
	public static void main (String[] args) {
		app.init();
		app.start();
		mainWin.setSize(640,480);
		mainWin.add(app);
		mainWin.show();
	} // main
} // copyManagerApplet