/*
	File: oCMThreadRead.java
	Autore: Tiziano Moretti
	Progetto: copyManager
	
	Thread usato in oneCopyManager. attende chiamate per le leggere dati e crea
	un apposito thread per soddisfare la richiesta
*/

import java.net.*;
import java.io.*;

public class oCMThreadRead implements Runnable{
	private int portaSckCl;
	private copiaLock myCopiaLock;
	
	public oCMThreadRead(int portaSckCl, copiaLock myCopiaLock){
		this.portaSckCl=portaSckCl;
		this.myCopiaLock=myCopiaLock;
	}//oCMThreadRead
	
	public void run(){
		ServerSocket masterSck=null;
		
		try{
			masterSck=new ServerSocket(portaSckCl);
			while(true){
				Socket sckClient=masterSck.accept();
				new Thread(new connRead(sckClient,myCopiaLock)).start();	
			}
		}catch(IOException exc1){
				System.out.println("Errore in sckClient in oCMThreadRead "+exc1);
				if(masterSck!=null) try{masterSck.close();}catch(IOException exc2)
					{System.out.println("Errore chiusura socket in oCMThreadRead "+ exc2);}
				System.exit(-1);
		}
	}//run
} // class oCMThreadRead